SystemOrganization addCategory: #GraphAlgorithms!

Object subclass: #GraphAlgorithms
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GraphAlgorithms'!

!GraphAlgorithms methodsFor: 'public - hooks' stamp: 'Deniels 12/19/2011 14:24'!
applyOn: view! !

!GraphAlgorithms methodsFor: 'public - hooks' stamp: 'Deniels 12/20/2011 16:29'!
highlight: nodes
	self applyOn: nodes.
	! !

GraphAlgorithms subclass: #GraphFindFreeNodes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GraphAlgorithms'!

!GraphFindFreeNodes methodsFor: 'public - hooks' stamp: 'Deniels 12/20/2011 16:31'!
applyOn: nodes
	"find all free nodes (i.e., a node that does not have an icoming and outgoing edge)"

	^ nodes select: [ :n | (n incomingEdges isEmpty) and: [ n outgoingEdges isEmpty ] ].
	! !

!GraphFindFreeNodes methodsFor: 'public - hooks' stamp: 'Deniels 12/20/2011 16:50'!
highlight: nodes
	(self applyOn: nodes) do: [ :node | node copyShapeAndDo: [ :shape | shape fillColor: Color red ]]! !

GraphAlgorithms subclass: #GraphFindMostFanInNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GraphAlgorithms'!

!GraphFindMostFanInNode methodsFor: 'public - hooks' stamp: 'Deniels 12/20/2011 22:39'!
applyOn: nodes
	"find a node that has the most incomingEdges"
	
	|maxFanIn theNode|
	maxFanIn := 0.
	nodes do:[:n | (n incomingEdges size > maxFanIn) ifTrue:[theNode := n. maxFanIn := n incomingEdges size]].
	^{theNode}! !

!GraphFindMostFanInNode methodsFor: 'public - hooks' stamp: 'Deniels 12/20/2011 22:35'!
highlight: nodes
	(self applyOn: nodes) do: [ :node | node copyShapeAndDo: [ :shape | shape fillColor: Color red ]]! !

GraphAlgorithms subclass: #GraphFindMostFanOutNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GraphAlgorithms'!

!GraphFindMostFanOutNode methodsFor: 'public - hooks' stamp: 'Deniels 12/20/2011 22:40'!
applyOn: nodes
	"find a node that has the most incomingEdges"
	
	|maxFanOut theNode|
	maxFanOut := 0.
	nodes do:[:n | (n outgoingEdges size > maxFanOut) ifTrue:[theNode := n. maxFanOut := n outgoingEdges size]].
	^{theNode}! !

!GraphFindMostFanOutNode methodsFor: 'public - hooks' stamp: 'Deniels 12/20/2011 22:41'!
highlight: nodes
	(self applyOn: nodes) do: [ :node | node copyShapeAndDo: [ :shape | shape fillColor: Color red ]]! !

TestCase subclass: #GraphAlgorithmsTest
	instanceVariableNames: 'nodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GraphAlgorithms'!

!GraphAlgorithmsTest methodsFor: 'running' stamp: 'Deniels 12/19/2011 15:12'!
setUp 
	|view|
	view := MOViewRenderer new.
	nodes :=view nodes: (1 to: 6).
	view edgesFromAssociations: {
		"the node 3 is free"
		"the node 1 has more than others outgoingEdges"
		"the node 5 has more than others incomingEdges"
		1 -> 2.
		1 -> 4.
		2 -> 5.
		1 -> 5
	}.! !

!GraphAlgorithmsTest methodsFor: 'tests' stamp: 'Deniels 12/20/2011 16:31'!
testGraphFindFreeNodes 
 	| res |
	res := GraphFindFreeNodes new applyOn: nodes.
	self assert: res asArray = { nodes third . nodes sixth }! !

!GraphAlgorithmsTest methodsFor: 'tests' stamp: 'Deniels 12/20/2011 16:31'!
testGraphFindMostFanInNode
	| res |
	res := GraphFindMostFanInNode new applyOn: nodes.
	self assert: res asArray = { nodes fifth }! !

!GraphAlgorithmsTest methodsFor: 'tests' stamp: 'Deniels 12/20/2011 16:31'!
testGraphFindMostFanOutNode
	| res |
	res := GraphFindMostFanOutNode new applyOn: nodes.
	self assert: res asArray = { nodes first }
	! !
